给出长度相同的两个字符串s1 和 s2 ,还有一个字符串 baseStr 。
其中 s1[i] 和 s2[i] 是一组等价字符。
举个例子,如果 s1 = “abc” 且 s2 = “cde”,那么就有 ‘a’ == ‘c’, ‘b’ == ‘d’, ‘c’ == ‘e’。
等价字符遵循任何等价关系的一般规则:
自反性 :‘a’ == ‘a’
对称性 :‘a’ == ‘b’ 则必定有 ‘b’ == ‘a’
传递性 :‘a’ == ‘b’ 且 ‘b’ == ‘c’ 就表明 ‘a’ == ‘c’
例如, s1 = “abc” 和 s2 = “cde” 的等价信息和之前的例子一样,那么 baseStr = “eed” , “acd” 或 “aab”,这三个字符串都是等价的,而 “aab” 是 baseStr 的按字典序最小的等价字符串
利用 s1 和 s2 的等价信息,找出并返回 baseStr 的按字典序排列最小的等价字符串。
示例 1:
输入:s1 = “parker”, s2 = “morris”, baseStr = “parser”
输出:“makkek”
解释:根据 A 和 B 中的等价信息,我们可以将这些字符分为 [m,p], [a,o], [k,r,s], [e,i] 共 4 组。每组中的字符都是等价的,并按字典序排列。所以答案是 “makkek”。
示例 2:
输入:s1 = “hello”, s2 = “world”, baseStr = “hold”
输出:“hdld”
解释:根据 A 和 B 中的等价信息,我们可以将这些字符分为 [h,w], [d,e,o], [l,r] 共 3 组。所以只有 S 中的第二个字符 ‘o’ 变成 ‘d’,最后答案为 “hdld”。
示例 3:
输入:s1 = “leetcode”, s2 = “programs”, baseStr = “sourcecode”
输出:“aauaaaaada”
解释:我们可以把 A 和 B 中的等价字符分为 [a,o,e,r,s,c], [l,p], [g,t] 和 [d,m] 共 4 组,因此 S 中除了 ‘u’ 和 ‘d’ 之外的所有字母都转化成了 ‘a’,最后答案为 “aauaaaaada”。
提示:
1 <= s1.length, s2.length, baseStr <= 1000
s1.length == s2.length
字符串s1, s2, and baseStr 仅由从 ‘a’ 到 ‘z’ 的小写英文字母组成。
并查集
class UnionFind{
private:
vector<int> parent;
vector<char> minChar;
public:
UnionFind(int n){
parent.resize(n);
minChar.resize(n);
for(int i = 0; i < n; i++){
parent[i] = i;
minChar[i] = 'a' + i;
}
}
void unite(int index1, int index2){
int root1 = find(index1);
int root2 = find(index2);
parent[root2] = root1;
minChar[root1] = min(minChar[root1], minChar[root2]); // 更新最小字母
}
int find(int index){
if(parent[index] == index){
return index;
}
parent[index] = find(parent[index]);
return parent[index];
}
char getMinChar(int index) {
return minChar[find(index)];
}
};
class Solution {
public:
string smallestEquivalentString(string s1, string s2, string baseStr) {
int n = s1.size();
UnionFind uf(26);
for(int i = 0; i < n; i++){
uf.unite(s1[i] - 'a', s2[i] - 'a');
}
string res = "";
for(char c : baseStr){
res += uf.getMinChar(c - 'a');
}
return res;
}
};
这道题我们可以推断出是使用了并查集的思想,由于这道题他只需要将baseStr修改成最小字典序等效字符串,所以我们只需要知道某个连通集中字典序最小的字符是多少,所以我们可以在合并字典序的时候,即在unite函数中来更新minChar的值。
需要注意的是,在unite里,我一开始写了:
parent[find(index2)] = find(index1);
minChar[find(index1)] = min(minChar[find(index1)], minChar[find(index2)]);
这样重复调用find会导致出现错误,因为我们在执行parent[find(index2)] = find(index1);
的时候,实际上find(index2)的父节点被更新为了find(index1),这回导致我们下一行代码中的find(index2)实际上是find(index1),那么这就会导致下一行代码minChar的更新没有意义。
我们合并了并查集后,我们定义一个变量res来记录结果,遍历baseStr的每一个字符,然后找到其连通集中最小字典序的字符加入到res中,最后res就是正确的结果。